#ifndef __BasisUtils__
#define __BasisUtils__

#include "FuncBases.h"
#include "Quad2d.h"

void MakeBasisMatrix(FunctionBasis &b, const QuadRule &rule, Matd &B);
//	Calculates basis matrix for a particular function basis and quadrature rule.

void MakeWeightMatrix(const QuadRule &rule, Matd &W);
//	Calculates weight matrix for a rule. (W will be diagonal.)

void FindConversionMatrix(FunctionBasis &bFrom, FunctionBasis &bTo, const QuadRule &rule,
	Matd &C);
// 	Given two function bases and a quadrature rule, finds a transformation
//	matrix from one basis to the other.

void MakeSubBasisMatrix(FunctionBasis &b, const QuadRule &rule, Int child, Int order, Matd &B);
//void MakeQuadSubBasisMatrix(FunctionBasis &b, const QuadRule &rule, Int child, Int order, Matd &B);
// Takes a basis, and returns the basis covering a sub-square of it.

//void MakeTriSubBasisMatrix(FunctionBasis &b, const QuadRule &rule, Int child, Int order, Matd &B);
// Takes a basis, and returns the basis covering a sub-triangle of it.

void MakeFlatletMatrices(FunctionBasis &basis, const QuadRule &rule, FunctionBasis &flatBasis,
	Int order, Matd &F, Matd &G);
// returns matrices to convert from rulei to Fi, and from Fi to rulei
// Most commonly used to convert from Multiwavelets to Flatlets and back.
// (E.g., An F2 pull can be accomplished by transforming to M2, doing an M2 pull,
// and transforming back to F2.)

//void MakeTriFlatletMatrices(FunctionBasis &basis, const QuadRule &rule, Int order, Matd &toF, Matd &fromF);
// returns matrices to convert from rulei to Fi, and from Fi to rulei

#endif
